import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.support.ConnectionSource;

    public class AccountApp {


        // we are using a MySQl database
        private final static String DATABASE_URL = "jdbc:mysql://localhost:3306/orm_lab?useUnicode=true";
        private final static String YOURUSERNAME = "root";
        private final static String YOURPASSWORD = "";
        private Console console = new Console();

        private Dao<Account, Integer> accountDao;

        public static void main(String[] args) throws Exception {
            // turn our static method into an instance of Main
            new AccountApp().doMain(args);
        }

        private void doMain(String[] args) throws Exception {
            ConnectionSource connectionSource = null;
            try {
                connectionSource = new JdbcConnectionSource(DATABASE_URL, YOURUSERNAME, YOURPASSWORD);
                setupDao(connectionSource);
                processData();
                console.print("Have a nice day");
            } finally {
                // destroy the data source which should close underlying connections
                if (connectionSource != null) {
                    connectionSource.close();
                }
            }
        }

        /**
         * Read and write some example data.
         */
        private void processData() throws Exception {
           AccountServ services = new AccountServ(accountDao);
           boolean end = false;
            console.print("Welcome to your account manager");
                while(!end){
                    console.printMenu();
                   int input = console.prntTakeInt("Please enter your selection: ");
                   switch (input) {
                       case 1 : services.createAccount();
                       break;
                       case 2 : int id = console.idCheck();
                       services.accountString(id);
                       break;
                       case 3 : services.updateAccount();
                       break;
                       case 4 : services.deleteAccount();
                           break;
                       case 5 : end = true; break;
                       default: console.invalid();
                            console.printMenu();
                   }

                }
        }

        /**
         * Setup our  DAOs
         */
        private void setupDao(ConnectionSource connectionSource) throws Exception {

            accountDao = DaoManager.createDao(connectionSource, Account.class);

        }
    }
