import com.j256.ormlite.dao.Dao;

import java.sql.SQLException;

public class AccountServ {

    private Dao<Account, Integer> dao;
    private Console console = new Console();

    public AccountServ(Dao<Account, Integer> dao) {
        this.dao = dao;
    }

    public void createAccount() throws SQLException {
        String name = console.prntTakeStr("Please enter new account name");
        String pswrd = console.prntTakeStr("Please enter new account password");
        Account account = new Account(name, pswrd);
        dao.create(account);
    }

    private int create(Account account) throws SQLException {
        return dao.create(account);
    }

    public Account read(int id) throws SQLException {
        return dao.queryForId(id);
    }

    public void accountString(int id) throws SQLException{
       Account account =  read(id);
       console.print("\n" + account.getName() + " " + account.getPassword() + "\n");
    }

    private Account getAcccount()throws SQLException {
        String input = console.prntTakeStr("Enter your account ID");
        return read(Integer.parseInt(input));
    }

    public void updateAccount() throws SQLException {
        Account account = getAcccount();
        int input = console.prntTakeInt("Enter 1 to change account password or 2 to change account name");
        if(input == 1) {setPassword(account);}
            else if (input == 2){
                setName(account);}
            else {console.invalid();}
    }

    private void setPassword(Account account) throws SQLException {
        String password =  console.prntTakeStr("Enter new password");
        account.setPassword(password);
        dao.update(account);
    }

    private void setName(Account account) throws SQLException {
        String name = console.prntTakeStr("Enter new name");
        account.setName(name);
        dao.update(account);
    }

    public void deleteAccount() throws SQLException{
        Account account = getAcccount();
        String input =  console.prntTakeStr("Are you sure you would like to delete your account?\nY / N");
        if (input.equalsIgnoreCase("y")){
            delete(account);
            console.print("Account deleted");
        } else {}
    }

    private int delete(Account account) throws SQLException {
        return dao.delete(account);
    }

}
