import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.stmt.query.In;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.sql.SQLException;

public class AccountServTest {

    Dao<Account, Integer> dao;
    Account account;
    AccountServ test;

    @Before
    public void setup() {
        dao = new MockDao();
        test = new AccountServ(dao);
        account = new Account("Bob", "password");
    }

    @Test
    public void createTest() throws SQLException {
        int expected = 100;
        int actual = dao.create(account);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void updateTest() throws SQLException {
        int expected = 300;
        int actual = dao.update(account);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void readTest() throws SQLException{
        Account expected = test.read(0);
        Account actual = dao.queryForId(0);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void destroyTest() throws SQLException{
        int expected = 200;
        int actual = dao.delete(account);

        Assert.assertEquals(expected, actual);
    }

}
